LeetCodeOJ——3. Longest Substring Without Repeating Characters

来源:互联网 发布:信捷plc的编程方法 编辑:程序博客网 时间:2024/06/06 08:23

Longest Substring Without Repeating Characters

Given a string, find the length of the longest substring without repeating characters.

Examples:

Given “abcabcbb”, the answer is “abc”, which the length is 3.

Given “bbbbb”, the answer is “b”, with the length of 1.

Given “pwwkew”, the answer is “wke”, with the length of 3. Note that the answer must be a substring, “pwke” is a subsequence and not a substring.

Subscribe to see which companies asked this question

解题思路:
解法1:
两个循环遍历子串(以字符串上的每一个字母为起点,寻找最长子串),并用set记录当前字母是否已经被访问过了,若被访问了则终止,j-i计算长度,最后筛选出最长的。

代码如下:

class Solution {public:    int lengthOfLongestSubstring(string s) {        if(s.length()==1){            return 1;        }        set<char> sx;        int *len = new int[s.length()];        for (int i = 0; i < s.length(); i++){            sx.clear();            int j = i;            for (;j < s.length(); j++){                if (sx.find(s[j])!=sx.end()){                    len[i] = j - i ;                    break;                }                else{                    sx.insert(s[j]);                }            }            if(j==s.length()){                len[i]=j-i;            }        }        int maxLen = 0;        for (int i = 0; i<s.length(); i++){            if (len[i]>maxLen){                maxLen = len[i];            }        }        return maxLen;    }};

很不幸,Time Limit Exceeded。
因此考虑解法2:动态规划,直接看代码吧。

class Solution {public:    int lengthOfLongestSubstring(string s) {        int *dp = new int[s.length()];        dp[0] = 1;        int last = 0;        for (int i = 1; i < s.length(); i++){            for (int j = i - 1; j >= 0; j--){                if (s[i] == s[j]){                    dp[i] = i - j;                    last = j + 1;                    break;                }                if (j == last){                    dp[i] = dp[i - 1] + 1;                    break;                }            }        }        int maxLen = 0;        for (int i = 0; i<s.length(); i++){            if (dp[i]>maxLen){                maxLen = dp[i];            }        }        return maxLen;    }};
0 0
原创粉丝点击